program Assembler_Examples;

{$M $4000,$2000,$4000 }

uses Crt, Ramka, Dos;

type

  PMenuItems=^TMenuItems;
  PMenuItem=^TMenuItem;
  PFileText=^TFileText;

  TFileText=record
    S: String[40];
    P: PFileText;
  end;

  TMenuItem=record
    S: String[30];
    P: PMenuItem;
    F: String[30];
  end;

  TMenuItems=record
    S: String[30];
    Item: PMenuItem;
    P: PMenuItems;
    F: String[30];
  end;

var BegItems, CurItems: PMenuItems;
    BegFile, CurFile: PFileText;
    CurItem: PMenuItem;
    MaxItems, MaxItem, n: Integer;
    C: Char;
    Sub: Boolean;
    P1, P2: String;

procedure NoCursor;
begin
  asm
    mov ah, 01
    mov ch, 13
    mov cl, 00
    int 10h
  end;
end;

procedure LoadFile(FileName: String);
  var f: Text;
      S: String;
      P: PFileText;

procedure DisposeAll;
  var P: PFileText;
begin
  CurFile:=BegFile;
  repeat
    P:=CurFile^.P;
    Dispose(CurFile);
    CurFile:=P;
  until P=nil;
end;

begin
  Assign(f, FileName);
  Reset(f);
  if BegFile<>nil then DisposeAll;
  repeat
    Readln(f, S);
    New(P);
    P^.S:=S;
    P^.P:=nil;
    CurFile^.P:=P;
    if BegFile=nil then BegFile:=P;
    CurFile:=P;
  until Eof(f);
end;

procedure ShowItems(From_, To_, Num: Integer);
  var i, k, m: Integer;
begin
  CurItems:=BegItems;
  i:=1;
  m:=2;
  repeat
    if i=Num then begin
      TextColor(14);
      TextBackGround(4);
    end
      else begin
        TextColor(15);
        TextBackGround(1);
      end;
    if (i>=From_) and (i<=To_) then begin
      GotoXY(1, m);
      Inc(m);
      Write(CurItems^.S);
      for k:=1 to 28-Length(CurItems^.S) do Write(' ');
    end;
    Inc(i);
    CurItems:=CurItems^.P;
  until CurItems=nil;
end;

procedure ExitDos;
begin
  Window(1, 1, 80, 25);
  TextColor(7);
  TextBackGround(0);
  ClrScr;
  asm
    mov ax, 4C00h
    int 21h
  end;
end;

procedure SetWindow(X1, Y1, X2, Y2, C1, C2: Byte; S: String);
begin
  Window(1, 1, 80, 25);
  ProcRamka(X1, Y1, X2, Y2, C1, C2, 2);
  GotoXY(((X2-X1) div 2)-(Length(S) div 2)+X1, Y1);
  TextColor(C1);
  TextBackGround(C2);
  Write(S);
  Window(X1+1, Y1+1, X2-1, Y2-1);
  TextColor(C1);
  TextBackGround(C2);
  ClrScr;
end;

procedure SetCurItems(i: Integer);
  var n: Integer;
begin
  CurItems:=BegItems;
  for n:=1 to i-1 do
    CurItems:=CurItems^.P;
end;

procedure ShowText;
  var i, MaxLen: Integer;
      C: Char;

procedure GetMaxLen;
  var i: Integer;
begin
  CurFile:=BegFile;
  MaxLen:=0;
  repeat
    Inc(MaxLen);
    CurFile:=CurFile^.P;
  until CurFile=nil;
end;

function GetStr(Num: Integer): String;
  var i: Integer;
begin
  CurFile:=BegFile;
  for i:=1 to Num do begin
    if i=Num then GetStr:=CurFile^.S;
    CurFile:=CurFile^.P;
  end;
end;

begin
  SetWindow(31, 1, 79, 25, 15, 7, 'ᠭ');
  GetMaxLen;
  GotoXY(1, 1);
  for i:=1 to 23 do
    if i<MaxLen then Writeln(GetStr(i));
  i:=1;
  repeat
    C:=ReadKey;
    if C=#72 then
      if i>1 then begin
        Dec(i);
        GotoXY(1, 1);
        InsLine;
        Write(GetStr(i));
      end;
    if C=#80 then
      if i<MaxLen-23 then begin
        Inc(i);
        GotoXY(1, 1);
        DelLine;
        GotoXY(1, 23);
        Write(GetStr(i+23));
      end;
  until C=#27;
end;

procedure SubMenu;
  var i, MaxItem: Integer;
      C: Char;

procedure CountMaxItem;
begin
  MaxItem:=0;
  CurItem:=CurItems^.Item;
  repeat
    Inc(MaxItem);
    CurItem:=CurItem^.P;
  until CurItem=nil;
end;

function GetStr(Num: Integer): String;
  var i: Integer;
begin
  CurItem:=CurItems^.Item;
  for i:=1 to Num do begin
    if i=Num then GetStr:=CurItem^.F;
    CurItem:=CurItem^.P;
  end;
end;

procedure ShowItem(From_, To_, Num: Integer);
  var i, k, m: Integer;
begin
  CurItem:=CurItems^.Item;
  i:=1;
  m:=2;
  repeat
    if i=Num then begin
      TextColor(14);
      TextBackGround(4);
    end
      else begin
        TextColor(15);
        TextBackGround(1);
      end;
    if (i>=From_) and (i<=To_) then begin
      GotoXY(1, m);
      Inc(m);
      Write(CurItem^.S);
      for k:=1 to 28-Length(CurItem^.S) do Write(' ');
    end;
    Inc(i);
    CurItem:=CurItem^.P;
  until CurItem=nil;
end;

begin
  CountMaxItem;
  ShowItem(1, MaxItem, 1);
  i:=1;
  repeat
    C:=ReadKey;
    if C=#80 then Inc(i);
    if i>MaxItem then i:=MaxItem;
    if C=#72 then Dec(i);
    if i<1 then i:=1;
    if C=#13 then begin
      if Sub then begin
        case i of
          1: begin
               LoadFile(P2+'\'+P1+'.asm');
               ShowText;
               Window(2, 2, 29, 24);
             end;
          2: begin
               Window(1, 1, 80, 25);
               TextColor(7);
               TextBackGround(0);
               ClrScr;
               Exec('e:\document\c\examples\'+P2+'\'+P1+'.com', '');
               ReadKey;
               SetWindow(31, 1, 79, 25, 15, 7, 'ᠭ');
               SetWindow(1, 1, 30, 25, 15, 1, ' ');
             end;
        end;
      end
        else begin
          P1:=GetStr(i);
          P2:=CurItems^.F;
          SetWindow(1, 1, 30, 25, 15, 1, ' ');
          SetCurItems(MaxItems+1);
          Sub:=True;
          SubMenu;
          Sub:=False;
          SetWindow(1, 1, 30, 25, 15, 1, ' ');
          SetCurItems(n);
          ShowItem(1, MaxItem, 1);
        end;
    end;
    ShowItem(1, MaxItem, i);
  until C=#27;
end;

procedure AddItems(S1, S2: String);
  var P: PMenuItems;
begin
  New(P);
  P^.S:=S1;
  P^.F:=S2;
  P^.P:=nil;
  P^.Item:=nil;
  if BegItems=nil then BegItems:=P
    else CurItems^.P:=P;
  CurItems:=P;
end;

procedure AddItem(S1, S2: String);
  var P: PMenuItem;
begin
  New(P);
  P^.S:=S1;
  P^.F:=S2;
  P^.P:=nil;
  if CurItems^.Item=nil then CurItems^.Item:=P
    else CurItem^.P:=P;
  CurItem:=P;
end;

procedure LoadItems(FileName: String);
  var f: Text;
      S1, S2, S: String;
      i: Integer;
begin
  MaxItems:=0;
  Assign(f, FileName);
  Reset(f);
  repeat
    Read(f, S1, S2);
    Readln(f, S2);
    Readln(f, S2);
    Inc(MaxItems);
    AddItems(S1, S2);
    Read(f, S1, S2);
    Readln(f, S2);
    Readln(f, S2);
    while S1<>'__________' do begin
      AddItem(S1, S2);
      Readln(f, S1);
      if S1<>'__________' then Readln(f, S2);
    end;
  until Eof(f);
  AddItems('室 - Esc', '');
  Inc(MaxItems);
  AddItems('Main', '');
  AddItem('ᬮ ணࠬ', '');
  AddItem(' ਬ', '');
  Close(f);
end;

begin
  TextBackGround(0);
  ClrScr;
  NoCursor;
  BegItems:=nil;
  BegFile:=nil;
  Sub:=False;
  LoadItems('examps.txt');
  SetWindow(31, 1, 79, 25, 15, 7, 'ᠭ');
  SetWindow(1, 1, 30, 25, 15, 1, ' ');
  ShowItems(1, MaxItems, 1);
  repeat
    C:=ReadKey;
    if C=#80 then Inc(n);
    if n>MaxItems then n:=MaxItems;
    if C=#72 then Dec(n);
    if n<1 then n:=1;
    if C=#13 then begin
      if n=MaxItems then ExitDos;
      SetCurItems(n);
      SetWindow(1, 1, 30, 25, 15, 1, ' ');
      SubMenu;
      SetWindow(1, 1, 30, 25, 15, 1, ' ');
    end;
    ShowItems(1, MaxItems, n);
  until C=#27;
  Window(1, 1, 80, 25);
  TextColor(0);
  TextBackGround(0);
  ClrScr;
end.