unit Topic;

{$F+,O+,X+,S-,D-}

interface

uses Drivers, Objects, Views, Dialogs;

type
    PTopicWindow = ^TopicWindow;
    TopicWindow = object(TDialog)
    List: PListBox;
    VScrollBar: PScrollBar;
    Button: PButton;
    constructor Load(var S: TStream);
    constructor Init(X, Y: Byte);
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure Store(var S: TStream);
  end;

implementation

procedure TopicWindow.HandleEvent(var Event: TEvent);
begin
  inherited HandleEvent(Event);
end;

constructor TopicWindow.Init(X, Y: Byte);
var
  R: TRect;
begin
  R.Assign(X, Y, X+35, Y+15);
  inherited Init(R, '롮 ⥬');

  R.Assign(32, 2, 33, 11);
  VScrollBar := New(PScrollBar, Init(R));
  VScrollBar^.SetParams(1, 1, 20, 20, 1);
  VScrollBar^.SetValue(1);
  Insert(VScrollBar);

  R.Assign(2, 2, 32, 11);
  List:=New(PListBox, Init(R, 1, VScrollBar));
  Insert(List);

  R.Assign(1, 12, 11, 14);
  Button:=New(PButton, Init(R, '~O~K', cmOk, 0));
  Insert(Button);

  R.Assign(12, 12, 22, 14);
  Button:=New(PButton, Init(R, '~~', cmCancel, 0));
  Insert(Button);

  R.Assign(23, 12, 33, 14);
  Button:=New(PButton, Init(R, '~~', cmHelp, 0));
  Insert(Button);

  SelectNext(False);

end;

constructor TopicWindow.Load(var S: TStream);
begin
  inherited Load(S);
  GetSubViewPtr(S, VScrollBar);
end;

procedure TopicWindow.Store(var S: TStream);
begin
  inherited Store(S);
  PutSubViewPtr(S, VScrollBar);
end;

end.
